/*
 * To change this template, choose Tools | Templates
 * and open the template in the editor.
 */

package lezione120410_libreria;

/**
 *
 * @author utente
 */
public class Libreria {

    private Libro [] A;
    private int nLibri;

    public Libreria (int n){
        A = new Libro[n];
        nLibri=0;
    }

   public int getNLibri(){
        return nLibri;
    }

    public Libro getLibro(int i){
        if (i<0 || i >= getNLibri()) {return null;}
        return A[i];
    }
   
   public int getCapienza(){
        return A.length;
    }

    public void addLibro (Libro l){
      if (nLibri>=A.length || in(l)) return;
      A[nLibri++]=l;
    }

    public Libro Search (String titolo){
        for (int i=0; i<nLibri; i++){
            if ( titolo.equalsIgnoreCase(A[i].getTitolo()) ) {return A[i];}
        }
        return null;
    }

    public Libro[] Search (Autore a){
        int conto=0;
        for (int i=0; i< nLibri ; i++){
            if (A[i].isAutore(a)){conto++;}
        }
        Libro [] B = new Libro [conto];
        int j=0;
        for (int i=0; i< nLibri ; i++){
            if (A[i].isAutore(a))
                {
                B[j]=A[i];
                j++;
                }
        }
        return B;
    }

    public String toString(){
        String s ="La libreria ha " + nLibri + " libri.\n";
        for (int i =0; i< nLibri; i++){
            s+="Libro n° "+ (i+1) +":\n";
            s+=A[i].toString();
            s+="\n----------------------------------------\n";
        }
        return s;
    }

    //verifica se il libro l è presente nella libreria corrente
    public boolean in (Libro l){
        for (int i =0; i<getNLibri(); i++){
            if (l.equals(getLibro(i))){return true;}
            //oppure: if (getLibro(i).equals(l){return true;}
        }
        return false;
    }

    //aggiunge alla libreria corrente tutti i libri della libreria lib
    public void Merge(Libreria lib){
        for (int i=0; i< lib.getNLibri();i++){
            addLibro(lib.getLibro(i));
        }
    }

    //crea una nuova libreria la cui capienza è data dalla somma delle capienze
    //e i cui libri sono l'unione dei libri delle 2 librerie (this e lib)
    public Libreria Union(Libreria lib){
       Libreria nuova = new Libreria (getCapienza()+lib.getCapienza());
       nuova.Merge(this);
       nuova.Merge(lib);
       return nuova;
    }

    //crea una nuova libreria la cui capienza è data dalla massima capienza tra
    //this e lib, e i cui libri sono l'intersezione dei libri delle 2 librerie
    public Libreria Intersection(Libreria lib){
        Libreria nuova;
        if (getCapienza() > lib.getCapienza()){
            nuova=new Libreria(getCapienza());
        } else {
            nuova=new Libreria(lib.getCapienza());
        }
        for (int i=0; i<getNLibri();i++){
            if (lib.in(getLibro(i))){nuova.addLibro(getLibro(i));}
        }
        return nuova;
    }


}
